tg-create.sh: only preload "[PATCH]" commit msgs
[topgit/pro.git] / tg.sh
blobbec68987e9d136af37a4553f61b772851d257d7c
1 #!/bin/sh
2 # TopGit - A different patch queue manager
3 # Copyright (C) Petr Baudis <pasky@suse.cz> 2008
4 # Copyright (C) Kyle J. McKay <mackyle@gmail.com> 2014,2015,2016
5 # All rights reserved.
6 # GPLv2
8 TG_VERSION=0.19.6
10 # Update in Makefile if you add any code that requires a newer version of git
11 GIT_MINIMUM_VERSION="@mingitver@"
13 ## SHA-1 pattern
15 octet='[0-9a-f][0-9a-f]'
16 octet4="$octet$octet$octet$octet"
17 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
18 octet20="$octet4$octet4$octet4$octet4$octet4"
19 nullsha="0000000000000000000000000000000000000000"
20 tab=' '
21 lf='
24 ## Auxiliary functions
26 # Preserves current $? value while triggering a non-zero set -e exit if active
27 # This works even for shells that sometimes fail to correctly trigger a -e exit
28 check_exit_code()
30 return $?
33 # This is the POSIX equivalent of which
34 cmd_path()
36 { "unset" -f command unset unalias "$1"; } >/dev/null 2>&1 || :
37 { "unalias" -a; } >/dev/null 2>&1 || :
38 command -v "$1"
41 # Output arguments without any possible interpretation
42 # (Avoid misinterpretation of '\' characters or leading "-n", "-E" or "-e")
43 echol()
45 printf '%s\n' "$*"
48 info()
50 echol "${TG_RECURSIVE}${tgname:-tg}: $*"
53 warn()
55 info "warning: $*" >&2
58 err()
60 info "error: $*" >&2
63 die()
65 info "fatal: $*" >&2
66 exit 1
69 # shift off first arg then return "$*" properly quoted in single-quotes
70 # if $1 was '' output goes to stdout otherwise it's assigned to $1
71 # the final \n, if any, is omitted from the result but any others are included
72 v_quotearg()
74 _quotearg_v="$1"
75 shift
76 set -- "$_quotearg_v" \
77 "sed \"s/'/'\\\\\\''/g;1s/^/'/;\\\$s/\\\$/'/;s/'''/'/g;1s/^''\\(.\\)/\\1/\"" "$*"
78 unset _quotearg_v
79 if [ -z "$3" ]; then
80 if [ -z "$1" ]; then
81 echo "''"
82 else
83 eval "$1=\"''\""
85 else
86 if [ -z "$1" ]; then
87 printf "%s$4" "$3" | eval "$2"
88 else
89 eval "$1="'"$(printf "%s$4" "$3" | eval "$2")"'
94 # same as v_quotearg except there's no extra $1 so output always goes to stdout
95 quotearg()
97 v_quotearg '' "$@"
100 vcmp()
102 # Compare $1 to $3 each of which must match ^[^0-9]*\d*(\.\d*)*.*$
103 # where only the "\d*" parts in the regex participate in the comparison
104 # Since EVERY string matches that regex this function is easy to use
105 # An empty string ('') for $1 or $3 or any "\d*" part is treated as 0
106 # $2 is a compare op '<', '<=', '=', '==', '!=', '>=', '>'
107 # Return code is 0 for true, 1 for false (or unknown compare op)
108 # There is NO difference in behavior between '=' and '=='
109 # Note that "vcmp 1.8 == 1.8.0.0.0.0" correctly returns 0
110 set -- "$1" "$2" "$3" "${1%%[0-9]*}" "${3%%[0-9]*}"
111 set -- "${1#"$4"}" "$2" "${3#"$5"}"
112 set -- "${1%%[!0-9.]*}" "$2" "${3%%[!0-9.]*}"
113 while
114 vcmp_a_="${1%%.*}"
115 vcmp_b_="${3%%.*}"
116 [ "z$vcmp_a_" != "z" -o "z$vcmp_b_" != "z" ]
118 if [ "${vcmp_a_:-0}" -lt "${vcmp_b_:-0}" ]; then
119 unset vcmp_a_ vcmp_b_
120 case "$2" in "<"|"<="|"!=") return 0; esac
121 return 1
122 elif [ "${vcmp_a_:-0}" -gt "${vcmp_b_:-0}" ]; then
123 unset vcmp_a_ vcmp_b_
124 case "$2" in ">"|">="|"!=") return 0; esac
125 return 1;
127 vcmp_a_="${1#$vcmp_a_}"
128 vcmp_b_="${3#$vcmp_b_}"
129 set -- "${vcmp_a_#.}" "$2" "${vcmp_b_#.}"
130 done
131 unset vcmp_a_ vcmp_b_
132 case "$2" in "="|"=="|"<="|">=") return 0; esac
133 return 1
136 precheck() {
137 if ! git_version="$(git version)"; then
138 die "'git version' failed"
140 case "$git_version" in [Gg]"it version "*);;*)
141 die "'git version' output does not start with 'git version '"
142 esac
144 vcmp "$git_version" '>=' "$GIT_MINIMUM_VERSION" ||
145 die "git version >= $GIT_MINIMUM_VERSION required but found $git_version instead"
148 case "$1" in version|--version|-V)
149 echo "TopGit version $TG_VERSION"
150 exit 0
151 esac
153 precheck
154 [ "$1" = "precheck" ] && exit 0
157 cat_depsmsg_internal()
159 _rev="$(ref_exists_rev "refs/heads/$1")" || return 0
160 if [ -s "$tg_cache_dir/$1/.$2" ]; then
161 if read _rev_match && [ "$_rev" = "$_rev_match" ]; then
162 _line=
163 while IFS= read -r _line || [ -n "$_line" ]; do
164 printf '%s\n' "$_line"
165 done
166 return 0
167 fi <"$tg_cache_dir/$1/.$2"
169 [ -d "$tg_cache_dir/$1" ] || mkdir -p "$tg_cache_dir/$1" 2>/dev/null || :
170 if [ -d "$tg_cache_dir/$1" ]; then
171 printf '%s\n' "$_rev" >"$tg_cache_dir/$1/.$2"
172 _line=
173 git cat-file blob "$_rev:.$2" 2>/dev/null |
174 while IFS= read -r _line || [ -n "$_line" ]; do
175 printf '%s\n' "$_line" >&3
176 printf '%s\n' "$_line"
177 done 3>>"$tg_cache_dir/$1/.$2"
178 else
179 git cat-file blob "$_rev:.$2" 2>/dev/null
183 # cat_deps BRANCHNAME
184 # Caches result
185 cat_deps()
187 cat_depsmsg_internal "$1" topdeps
190 # cat_msg BRANCHNAME
191 # Caches result
192 cat_msg()
194 cat_depsmsg_internal "$1" topmsg
197 # cat_file TOPIC:PATH [FROM]
198 # cat the file PATH from branch TOPIC when FROM is empty.
199 # FROM can be -i or -w, than the file will be from the index or worktree,
200 # respectively. The caller should than ensure that HEAD is TOPIC, to make sense.
201 cat_file()
203 path="$1"
204 case "$2" in
206 cat "$root_dir/${path#*:}"
209 # ':file' means cat from index
210 git cat-file blob ":${path#*:}"
213 case "$path" in
214 refs/heads/*:.topdeps)
215 _temp="${path%:.topdeps}"
216 cat_deps "${_temp#refs/heads/}"
218 refs/heads/*:.topmsg)
219 _temp="${path%:.topmsg}"
220 cat_msg "${_temp#refs/heads/}"
223 git cat-file blob "$path"
225 esac
228 die "Wrong argument to cat_file: '$2'"
230 esac
233 # get tree for the committed topic
234 get_tree_()
236 echo "refs/heads/$1"
239 # get tree for the base
240 get_tree_b()
242 echo "refs/$topbases/$1"
245 # get tree for the index
246 get_tree_i()
248 git write-tree
251 # get tree for the worktree
252 get_tree_w()
254 i_tree=$(git write-tree)
256 # the file for --index-output needs to sit next to the
257 # current index file
258 cd "$root_dir"
259 : ${GIT_INDEX_FILE:="$git_dir/index"}
260 TMP_INDEX="$(mktemp "${GIT_INDEX_FILE}-tg.XXXXXX")"
261 git read-tree -m $i_tree --index-output="$TMP_INDEX" &&
262 GIT_INDEX_FILE="$TMP_INDEX" &&
263 export GIT_INDEX_FILE &&
264 git diff --name-only -z HEAD |
265 git update-index -z --add --remove --stdin &&
266 git write-tree &&
267 rm -f "$TMP_INDEX"
271 # strip_ref "$(git symbolic-ref HEAD)"
272 # Output will have a leading refs/heads/ or refs/$topbases/ stripped if present
273 strip_ref()
275 case "$1" in
276 refs/"$topbases"/*)
277 echol "${1#refs/$topbases/}"
279 refs/heads/*)
280 echol "${1#refs/heads/}"
283 echol "$1"
284 esac
287 # pretty_tree NAME [-b | -i | -w]
288 # Output tree ID of a cleaned-up tree without tg's artifacts.
289 # NAME will be ignored for -i and -w, but needs to be present
290 pretty_tree()
292 name=$1
293 source=${2#?}
294 git ls-tree --full-tree "$(get_tree_$source "$name")" |
295 LC_ALL=C sed -ne '/ \.top.*$/!p' |
296 git mktree
299 # return an empty-tree root commit -- date is either passed in or current
300 # If passed in "$*" must be epochsecs followed by optional hhmm offset (+0000 default)
301 # An invalid secs causes the current date to be used, an invalid zone offset
302 # causes +0000 to be used
303 make_empty_commit()
305 # the empty tree is guaranteed to always be there even in a repo with
306 # zero objects, but for completeness we force it to exist as a real object
307 SECS=
308 read -r SECS ZONE JUNK <<-EOT || :
311 case "$SECS" in *[!0-9]*) SECS=; esac
312 if [ -z "$SECS" ]; then
313 MTDATE="$(date '+%s %z')"
314 else
315 case "$ZONE" in
316 -[01][0-9][0-5][0-9]|+[01][0-9][0-5][0-9])
318 [01][0-9][0-5][0-9])
319 ZONE="+$ZONE"
322 ZONE="+0000"
323 esac
324 MTDATE="$SECS $ZONE"
326 EMPTYID="- <-> $MTDATE"
327 EMPTYTREE="$(git hash-object -t tree -w --stdin < /dev/null)"
328 printf '%s\n' "tree $EMPTYTREE" "author $EMPTYID" "committer $EMPTYID" '' |
329 git hash-object -t commit -w --stdin
332 # setup_hook NAME
333 setup_hook()
335 tgname="${0##*/}"
336 hook_call="\"\$(\"$tgname\" --hooks-path)\"/$1 \"\$@\""
337 if [ -f "$git_hooks_dir/$1" ] && LC_ALL=C grep -Fq "$hook_call" "$git_hooks_dir/$1"; then
338 # Another job well done!
339 return
341 # Prepare incantation
342 hook_chain=
343 if [ -s "$git_hooks_dir/$1" -a -x "$git_hooks_dir/$1" ]; then
344 hook_call="$hook_call"' || exit $?'
345 if [ -L "$git_hooks_dir/$1" ] || ! LC_ALL=C sed -n 1p <"$git_hooks_dir/$1" | LC_ALL=C grep -Fqx "#!@SHELL_PATH@"; then
346 chain_num=
347 while [ -e "$git_hooks_dir/$1-chain$chain_num" ]; do
348 chain_num=$(( $chain_num + 1 ))
349 done
350 mv -f "$git_hooks_dir/$1" "$git_hooks_dir/$1-chain$chain_num"
351 hook_chain=1
353 else
354 hook_call="exec $hook_call"
355 [ -d "$git_hooks_dir" ] || mkdir -p "$git_hooks_dir" || :
357 # Don't call hook if tg is not installed
358 hook_call="if command -v \"$tgname\" >/dev/null 2>&1; then $hook_call; fi"
359 # Insert call into the hook
361 echol "#!@SHELL_PATH@"
362 echol "$hook_call"
363 if [ -n "$hook_chain" ]; then
364 echol "exec \"\$0-chain$chain_num\" \"\$@\""
365 else
366 [ ! -s "$git_hooks_dir/$1" ] || cat "$git_hooks_dir/$1"
368 } >"$git_hooks_dir/$1+"
369 chmod a+x "$git_hooks_dir/$1+"
370 mv "$git_hooks_dir/$1+" "$git_hooks_dir/$1"
373 # setup_ours (no arguments)
374 setup_ours()
376 if [ ! -s "$git_common_dir/info/attributes" ] || ! grep -q topmsg "$git_common_dir/info/attributes"; then
377 [ -d "$git_common_dir/info" ] || mkdir "$git_common_dir/info"
379 echo ".topmsg merge=ours"
380 echo ".topdeps merge=ours"
381 } >>"$git_common_dir/info/attributes"
383 if ! git config merge.ours.driver >/dev/null; then
384 git config merge.ours.name '"always keep ours" merge driver'
385 git config merge.ours.driver 'touch %A'
389 # measure_branch NAME [BASE] [EXTRAHEAD...]
390 measure_branch()
392 _bname="$1"; _base="$2"
393 shift; shift
394 [ -n "$_base" ] || _base="refs/$topbases/$(strip_ref "$_bname")"
395 # The caller should've verified $name is valid
396 _commits="$(git rev-list --count "$_bname" "$@" ^"$_base" --)"
397 _nmcommits="$(git rev-list --count --no-merges "$_bname" "$@" ^"$_base" --)"
398 if [ $_commits -ne 1 ]; then
399 _suffix="commits"
400 else
401 _suffix="commit"
403 echo "$_commits/$_nmcommits $_suffix"
406 # branch_contains B1 B2
407 # Whether B1 is a superset of B2.
408 branch_contains()
410 _revb1="$(ref_exists_rev "$1")" || return 0
411 _revb2="$(ref_exists_rev "$2")" || return 0
412 if [ -s "$tg_cache_dir/$1/.bc/$2/.d" ]; then
413 if read _result _rev_matchb1 _rev_matchb2 &&
414 [ "$_revb1" = "$_rev_matchb1" -a "$_revb2" = "$_rev_matchb2" ]; then
415 return $_result
416 fi <"$tg_cache_dir/$1/.bc/$2/.d"
418 [ -d "$tg_cache_dir/$1/.bc/$2" ] || mkdir -p "$tg_cache_dir/$1/.bc/$2" 2>/dev/null || :
419 _result=0
420 [ "$(git rev-list --count --max-count=1 "$_revb2" --not "$_revb1" --)" = "0" ] || _result=1
421 if [ -d "$tg_cache_dir/$1/.bc/$2" ]; then
422 echo "$_result" "$_revb1" "$_revb2" >"$tg_cache_dir/$1/.bc/$2/.d"
424 return $_result
427 create_ref_dirs()
429 [ ! -s "$tg_tmp_dir/tg~ref-dirs-created" -a -s "$tg_ref_cache" ] || return 0
430 sed -e 's/ .*$//;'"s~^~$tg_tmp_dir/cached/~" <"$tg_ref_cache" | xargs mkdir -p
431 echo 1 >"$tg_tmp_dir/tg~ref-dirs-created"
434 # If the first argument is non-empty, stores "1" there if this call created the cache
435 v_create_ref_cache()
437 [ -n "$tg_ref_cache" -a ! -s "$tg_ref_cache" ] || return 0
438 _remotespec=
439 [ -z "$base_remote" ] || _remotespec="refs/remotes/$base_remote"
440 [ -z "$1" ] || eval "$1=1"
441 git for-each-ref --format='%(refname) %(objectname)' \
442 refs/heads "refs/$topbases" $_remotespec >"$tg_ref_cache"
443 create_ref_dirs
446 remove_ref_cache()
448 [ -n "$tg_ref_cache" -a -s "$tg_ref_cache" ] || return 0
449 >"$tg_ref_cache"
452 # setting tg_ref_cache_only to non-empty will force non-$tg_ref_cache lookups to fail
453 rev_parse()
455 if [ -n "$tg_ref_cache" -a -s "$tg_ref_cache" ]; then
456 LC_ALL=C awk -v r="$1" 'BEGIN {e=1}; $1 == r {print $2; e=0; exit}; END {exit e}' <"$tg_ref_cache"
457 else
458 [ -z "$tg_ref_cache_only" ] || return 1
459 git rev-parse --quiet --verify "$1^0" -- 2>/dev/null
463 # ref_exists_rev REF
464 # Whether REF is a valid ref name
465 # REF must be fully qualified and start with refs/heads/, refs/$topbases/
466 # or, if $base_remote is set, refs/remotes/$base_remote/
467 # Caches result if $tg_read_only and outputs HASH on success
468 ref_exists_rev()
470 case "$1" in
471 refs/*)
473 $octet20)
474 printf '%s' "$1"
475 return;;
477 die "ref_exists_rev requires fully-qualified ref name"
478 esac
479 [ -n "$tg_read_only" ] || { git rev-parse --quiet --verify "$1^0" -- 2>/dev/null; return; }
480 _result=
481 _result_rev=
482 { read -r _result _result_rev <"$tg_tmp_dir/cached/$1/.ref"; } 2>/dev/null || :
483 [ -z "$_result" ] || { printf '%s' "$_result_rev"; return $_result; }
484 _result_rev="$(rev_parse "$1")"
485 _result=$?
486 [ -d "$tg_tmp_dir/cached/$1" ] || mkdir -p "$tg_tmp_dir/cached/$1" 2>/dev/null
487 [ ! -d "$tg_tmp_dir/cached/$1" ] ||
488 echo $_result $_result_rev >"$tg_tmp_dir/cached/$1/.ref" 2>/dev/null || :
489 printf '%s' "$_result_rev"
490 return $_result
493 # Same as ref_exists_rev but output is abbreviated hash
494 # Optional second argument defaults to --short but may be any --short=.../--no-short option
495 ref_exists_rev_short()
497 case "$1" in
498 refs/*)
500 $octet20)
503 die "ref_exists_rev_short requires fully-qualified ref name"
504 esac
505 [ -n "$tg_read_only" ] || { git rev-parse --quiet --verify ${2:---short} "$1^0" -- 2>/dev/null; return; }
506 _result=
507 _result_rev=
508 { read -r _result _result_rev <"$tg_tmp_dir/cached/$1/.rfs"; } 2>/dev/null || :
509 [ -z "$_result" ] || { printf '%s' "$_result_rev"; return $_result; }
510 _result_rev="$(rev_parse "$1")"
511 _result=$?
512 if [ $_result -eq 0 ]; then
513 _result_rev="$(git rev-parse --verify ${2:---short} --quiet "$_result_rev" --)"
514 _result=$?
516 [ -d "$tg_tmp_dir/cached/$1" ] || mkdir -p "$tg_tmp_dir/cached/$1" 2>/dev/null
517 [ ! -d "$tg_tmp_dir/cached/$1" ] ||
518 echo $_result $_result_rev >"$tg_tmp_dir/cached/$1/.rfs" 2>/dev/null || :
519 printf '%s' "$_result_rev"
520 return $_result
523 # ref_exists REF
524 # Whether REF is a valid ref name
525 # REF must be fully qualified and start with refs/heads/, refs/$topbases/
526 # or, if $base_remote is set, refs/remotes/$base_remote/
527 # Caches result
528 ref_exists()
530 ref_exists_rev "$1" >/dev/null
533 # rev_parse_tree REF
534 # Runs git rev-parse REF^{tree}
535 # Caches result if $tg_read_only
536 rev_parse_tree()
538 [ -n "$tg_read_only" ] || { git rev-parse --verify "$1^{tree}" -- 2>/dev/null; return; }
539 if [ -f "$tg_tmp_dir/cached/$1/.rpt" ]; then
540 if IFS= read -r _result <"$tg_tmp_dir/cached/$1/.rpt"; then
541 printf '%s\n' "$_result"
542 return 0
544 return 1
546 [ -d "$tg_tmp_dir/cached/$1" ] || mkdir -p "$tg_tmp_dir/cached/$1" 2>/dev/null || :
547 if [ -d "$tg_tmp_dir/cached/$1" ]; then
548 git rev-parse --verify "$1^{tree}" -- >"$tg_tmp_dir/cached/$1/.rpt" 2>/dev/null || :
549 if IFS= read -r _result <"$tg_tmp_dir/cached/$1/.rpt"; then
550 printf '%s\n' "$_result"
551 return 0
553 return 1
555 git rev-parse --verify "$1^{tree}" -- 2>/dev/null
558 # has_remote BRANCH
559 # Whether BRANCH has a remote equivalent (accepts ${topbases#heads/}/ too)
560 has_remote()
562 [ -n "$base_remote" ] && ref_exists "refs/remotes/$base_remote/$1"
565 # Return the verified TopGit branch name or die with an error.
566 # As a convenience, if HEAD or @ is given and HEAD is a symbolic ref to
567 # refs/heads/... then ... will be verified instead.
568 # if "$2" = "-f" (for fail) then return an error rather than dying.
569 verify_topgit_branch()
571 case "$1" in
572 refs/"$topbases"/*)
573 _verifyname="${1#refs/$topbases/}"
575 refs/heads/*)
576 _verifyname="${1#refs/heads/}"
578 HEAD|@)
579 _verifyname="$(git symbolic-ref HEAD 2>/dev/null)" || :
580 [ -n "$_verifyname" -o "$2" = "-f" ] || die "HEAD is not a symbolic ref"
581 case "$_verifyname" in refs/heads/*);;*)
582 [ "$2" != "-f" ] || return 1
583 die "HEAD is not a symbolic ref to the refs/heads namespace"
584 esac
585 _verifyname="${_verifyname#refs/heads/}"
588 _verifyname="$1"
590 esac
591 if ! ref_exists "refs/heads/$_verifyname"; then
592 [ "$2" != "-f" ] || return 1
593 die "no such branch: $_verifyname"
595 if ! ref_exists "refs/$topbases/$_verifyname"; then
596 [ "$2" != "-f" ] || return 1
597 die "not a TopGit-controlled branch: $_verifyname"
599 printf '%s' "$_verifyname"
602 # Caches result
603 # $1 = branch name (i.e. "t/foo/bar")
604 # $2 = optional result of rev-parse "refs/heads/$1"
605 # $3 = optional result of rev-parse "refs/$topbases/$1"
606 branch_annihilated()
608 _branch_name="$1"
609 _rev="${2:-$(ref_exists_rev "refs/heads/$_branch_name")}"
610 _rev_base="${3:-$(ref_exists_rev "refs/$topbases/$_branch_name")}"
612 _result=
613 _result_rev=
614 _result_rev_base=
615 { read -r _result _result_rev _result_rev_base <"$tg_cache_dir/$_branch_name/.ann"; } 2>/dev/null || :
616 [ -z "$_result" -o "$_result_rev" != "$_rev" -o "$_result_rev_base" != "$_rev_base" ] || return $_result
618 # use the merge base in case the base is ahead.
619 mb="$(git merge-base "$_rev_base" "$_rev" 2>/dev/null)"
621 test -z "$mb" || test "$(rev_parse_tree "$mb")" = "$(rev_parse_tree "$_rev")"
622 _result=$?
623 [ -d "$tg_cache_dir/$_branch_name" ] || mkdir -p "$tg_cache_dir/$_branch_name" 2>/dev/null
624 [ ! -d "$tg_cache_dir/$_branch_name" ] ||
625 echo $_result $_rev $_rev_base >"$tg_cache_dir/$_branch_name/.ann" 2>/dev/null || :
626 return $_result
629 non_annihilated_branches()
631 [ $# -gt 0 ] || set -- "refs/$topbases"
632 git for-each-ref --format='%(objectname) %(refname)' "$@" |
633 while read rev ref; do
634 name="${ref#refs/$topbases/}"
635 if branch_annihilated "$name" "" "$rev"; then
636 continue
638 echol "$name"
639 done
642 # Make sure our tree is clean
643 ensure_clean_tree()
645 check_status
646 [ -z "$tg_state$git_state" ] || { do_status; exit 1; }
647 git update-index --ignore-submodules --refresh ||
648 die "the working directory has uncommitted changes (see above) - first commit or reset them"
649 [ -z "$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)" ] ||
650 die "the index has uncommited changes"
653 # is_sha1 REF
654 # Whether REF is a SHA1 (compared to a symbolic name).
655 is_sha1()
657 case "$1" in $octet20) return 0;; esac
658 return 1
661 # recurse_deps_internal NAME [BRANCHPATH...]
662 # get recursive list of dependencies with leading 0 if branch exists 1 if missing
663 # followed by a 1 if the branch is "tgish" or a 0 if not
664 # followed by a 0 for a non-leaf, 1 for a leaf or 2 for annihilated tgish
665 # but missing and remotes are always "0"
666 # then the branch name followed by its depedency chain (which might be empty)
667 # An output line might look like this:
668 # 0 1 1 t/foo/leaf t/foo/int t/stage
669 # If no_remotes is non-empty, exclude remotes
670 # If recurse_preorder is non-empty, do a preorder rather than postorder traversal
671 # but the leaf info will always be 0 or 2 in that case
672 # If with_top_level is non-empty, include the top-level that's normally omitted
673 # any branch names in the space-separated recurse_deps_exclude variable
674 # are skipped (along with their dependencies)
675 recurse_deps_internal()
677 case " $recurse_deps_exclude " in *" $1 "*) return 0; esac
678 _ref_hash=
679 if ! _ref_hash="$(ref_exists_rev "refs/heads/$1")"; then
680 [ -z "$2" ] || echo "1 0 0 $*"
681 return 0
684 _is_tgish=0
685 _ref_hash_base=
686 _is_leaf=0
687 ! _ref_hash_base="$(ref_exists_rev "refs/$topbases/$1")" || _is_tgish=1
688 [ "$_is_tgish" = "0" ] || ! branch_annihilated "$1" "$_ref_hash" "$_ref_hash_base" || _is_leaf=2
689 [ -z "$recurse_preorder" -o -z "${2:-$with_top_level}" ] || echo "0 $_is_tgish $_is_leaf $*"
691 # If no_remotes is unset also check our base against remote base.
692 # Checking our head against remote head has to be done in the helper.
693 if [ "$_is_tgish" = "1" ] && [ -z "$no_remotes" ] && has_remote "${topbases#heads/}/$1"; then
694 echo "0 0 0 refs/remotes/$base_remote/${topbases#heads/}/$1 $*"
697 # if the branch was annihilated, it is considered to have no dependencies
698 [ "$_is_leaf" = "2" ] || _is_leaf=1
699 if [ "$_is_tgish" = "1" ] && [ "$_is_leaf" = "1" ]; then
700 #TODO: handle nonexisting .topdeps?
701 while read _dname && [ -n "$_dname" ]; do
702 # Avoid depedency loops
703 case " $* " in *" $_dname "*)
704 warn "dependency loop detected in branch $_dname"
705 _is_leaf=0
706 continue
707 esac
708 # Shoo shoo, leave our environment alone!
709 _dep_is_leaf=0
710 (recurse_deps_internal "$_dname" "$@") || _dep_is_leaf=$?
711 [ "$_dep_is_leaf" = "2" ] || _is_leaf=0
712 done <<-EOT
713 $(cat_deps "$1")
717 [ -n "$recurse_preorder" -o -z "${2:-$with_top_level}" ] || echo "0 $_is_tgish $_is_leaf $*"
718 return ${_is_leaf:-0}
721 # do_eval CMD
722 # helper for recurse_deps so that a return statement executed inside CMD
723 # does not return from recurse_deps. This shouldn't be necessary, but it
724 # seems that it actually is.
725 do_eval()
727 eval "$@"
730 # becomes read-only for caching purposes
731 # assigns new value to tg_read_only
732 # become_cacheable/undo_become_cacheable calls may be nested
733 become_cacheable()
735 _old_tg_read_only="$tg_read_only"
736 if [ -z "$tg_read_only" ]; then
737 ! [ -e "$tg_tmp_dir/cached" ] && ! [ -e "$tg_tmp_dir/tg~ref-dirs-created" ] ||
738 rm -rf "$tg_tmp_dir/cached" "$tg_tmp_dir/tg~ref-dirs-created"
739 tg_read_only=1
741 _my_ref_cache=
742 v_create_ref_cache _my_ref_cache
743 _my_ref_cache="${_my_ref_cache:+1}"
744 tg_read_only="undo${_my_ref_cache:-0}-$_old_tg_read_only"
747 # restores tg_read_only and ref_cache to state before become_cacheable call
748 # become_cacheable/undo_bocome_cacheable calls may be nested
749 undo_become_cacheable()
751 case "$tg_read_only" in
752 "undo"[01]"-"*)
753 _suffix="${tg_read_only#undo?-}"
754 [ "${tg_read_only%$_suffix}" = "undo0-" ] || remove_ref_cache
755 tg_read_only="$_suffix"
756 esac
759 # just call this, no undo, sets tg_read_only= and removes ref cache and cached results
760 become_non_cacheable()
762 remove_ref_cache
763 tg_read_only=
764 ! [ -e "$tg_tmp_dir/cached" ] && ! [ -e "$tg_tmp_dir/tg~ref-dirs-created" ] ||
765 rm -rf "$tg_tmp_dir/cached" "$tg_tmp_dir/tg~ref-dirs-created"
768 # call this to make sure Git will not complain about a missing user/email
769 # result is cached in TG_IDENT_CHECKED and a non-empty value suppresses the check
770 ensure_ident_available()
772 [ -z "$TG_IDENT_CHECKED" ] || return 0
773 git var GIT_AUTHOR_IDENT >/dev/null &&
774 git var GIT_COMMITTER_IDENT >/dev/null || exit
775 TG_IDENT_CHECKED=1
776 export TG_IDENT_CHECKED
777 return 0
780 # recurse_deps CMD NAME [BRANCHPATH...]
781 # Recursively eval CMD on all dependencies of NAME.
782 # Dependencies are visited in topological order.
783 # CMD can refer to $_name for queried branch name,
784 # $_dep for dependency name,
785 # $_depchain for space-seperated branch backtrace,
786 # $_dep_missing boolean to check whether $_dep is present
787 # and the $_dep_is_tgish and $_dep_annihilated booleans.
788 # If recurse_preorder is NOT set then the $_dep_is_leaf boolean is also valid.
789 # It can modify $_ret to affect the return value
790 # of the whole function.
791 # If recurse_deps() hits missing dependencies, it will append
792 # them to space-separated $missing_deps list and skip them
793 # after calling CMD with _dep_missing set.
794 # remote dependencies are processed if no_remotes is unset.
795 # any branch names in the space-separated recurse_deps_exclude variable
796 # are skipped (along with their dependencies)
797 recurse_deps()
799 _cmd="$1"; shift
801 become_cacheable
802 _depsfile="$(get_temp tg-depsfile)"
803 recurse_deps_internal "$@" >>"$_depsfile" || :
804 undo_become_cacheable
806 _ret=0
807 while read _ismissing _istgish _isleaf _dep _name _deppath; do
808 _depchain="$_name${_deppath:+ $_deppath}"
809 _dep_is_tgish=
810 [ "$_istgish" = "0" ] || _dep_is_tgish=1
811 _dep_missing=
812 if [ "$_ismissing" != "0" ]; then
813 _dep_missing=1
814 case " $missing_deps " in *" $_dep "*);;*)
815 missing_deps="${missing_deps:+$missing_deps }$_dep"
816 esac
818 _dep_annihilated=
819 _dep_is_leaf=
820 if [ "$_isleaf" = "1" ]; then
821 _dep_is_leaf=1
822 elif [ "$_isleaf" = "2" ]; then
823 _dep_annihilated=1
825 do_eval "$_cmd"
826 done <"$_depsfile"
827 rm -f "$_depsfile"
828 return $_ret
831 find_leaves_internal()
833 if [ -n "$_dep_is_leaf" ] && [ -z "$_dep_annihilated" ] && [ -z "$_dep_missing" ]; then
834 if [ -n "$_dep_is_tgish" ]; then
835 fulldep="refs/$topbases/$_dep"
836 else
837 fulldep="refs/heads/$_dep"
839 case " $seen_leaf_refs " in *" $fulldep "*);;*)
840 seen_leaf_refs="${seen_leaf_refs:+$seen_leaf_refs }$fulldep"
841 if fullrev="$(ref_exists_rev "$fulldep")"; then
842 case " $seen_leaf_revs " in *" $fullrev "*);;*)
843 seen_leaf_revs="${seen_leaf_revs:+$seen_leaf_revs }$fullrev"
844 # See if Git knows it by another name
845 if tagname="$(git describe --exact-match "$fullrev" 2>/dev/null)" && [ -n "$tagname" ]; then
846 echo "refs/tags/$tagname"
847 else
848 echo "$fulldep"
850 esac
852 esac
856 # find_leaves NAME
857 # output (one per line) the unique leaves of NAME
858 # a leaf is either
859 # 1) a non-tgish dependency
860 # 2) the base of a tgish dependency with no non-annihilated dependencies
861 # duplicates are suppressed (by commit rev) and remotes are always ignored
862 # if a leaf has an exact tag match that will be output
863 # note that recurse_deps_exclude IS honored for this operation
864 find_leaves()
866 no_remotes=1
867 with_top_level=1
868 recurse_preorder=
869 seen_leaf_refs=
870 seen_leaf_revs=
871 recurse_deps find_leaves_internal "$1"
872 with_top_level=
875 # branch_needs_update
876 # This is a helper function for determining whether given branch
877 # is up-to-date wrt. its dependencies. It expects input as if it
878 # is called as a recurse_deps() helper.
879 # In case the branch does need update, it will echo it together
880 # with the branch backtrace on the output (see needs_update()
881 # description for details) and set $_ret to non-zero.
882 branch_needs_update()
884 if [ -n "$_dep_missing" ]; then
885 echo "! $_dep $_depchain"
886 return 0
889 if [ -n "$_dep_is_tgish" ]; then
890 branch_annihilated "$_dep" && return 0
892 if has_remote "$_dep"; then
893 branch_contains "refs/heads/$_dep" "refs/remotes/$base_remote/$_dep" ||
894 echo "refs/remotes/$base_remote/$_dep $_dep $_depchain"
896 # We want to sync with our base first and should output this before
897 # the remote branch, but the order does not actually matter to tg-update
898 # as it just recurses regardless, but it does matter for tg-info (which
899 # treats out-of-date bases as though they were already merged in) so
900 # we output the remote before the base.
901 branch_contains "refs/heads/$_dep" "refs/$topbases/$_dep" || {
902 echo ": $_dep $_depchain"
903 _ret=1
904 return
908 if [ -n "$_name" ]; then
909 case "$_dep" in refs/*) _fulldep="$_dep";; *) _fulldep="refs/heads/$_dep";; esac
910 if ! branch_contains "refs/$topbases/$_name" "$_fulldep"; then
911 # Some new commits in _dep
912 echo "$_dep $_depchain"
913 _ret=1
918 # needs_update NAME
919 # This function is recursive; it outputs reverse path from NAME
920 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
921 # inner paths first. Innermost name can be refs/remotes/<remote>/<name>
922 # if the head is not in sync with the <remote> branch <name>, ':' if
923 # the head is not in sync with the base (in this order of priority)
924 # or '!' if dependency is missing. Note that the remote branch, base
925 # order is reversed from the order they will actually be updated in
926 # order to accomodate tg info which treats out-of-date items that are
927 # only in the base as already being in the head for status purposes.
928 # It will also return non-zero status if NAME needs update.
929 # If needs_update() hits missing dependencies, it will append
930 # them to space-separated $missing_deps list and skip them.
931 needs_update()
933 recurse_deps branch_needs_update "$1"
936 # branch_empty NAME [-i | -w]
937 branch_empty()
939 if [ -z "$2" ]; then
940 _rev="$(ref_exists_rev "refs/heads/$1")" || return 0
941 _result=
942 _result_rev=
943 { read -r _result _result_rev <"$tg_cache_dir/$1/.mt"; } 2>/dev/null || :
944 [ -z "$_result" -o "$_result_rev" != "$_rev" ] || return $_result
945 _result=0
946 [ "$(pretty_tree "$1" -b)" = "$(pretty_tree "$1" $2)" ] || _result=$?
947 [ -d "$tg_cache_dir/$1" ] || mkdir -p "$tg_cache_dir/$1" 2>/dev/null
948 [ ! -d "$tg_cache_dir/$1" ] || echo $_result $_rev >"$tg_cache_dir/$1/.mt"
949 return $_result
950 else
951 [ "$(pretty_tree "$1" -b)" = "$(pretty_tree "$1" $2)" ]
955 # list_deps [-i | -w] [BRANCH]
956 # -i/-w apply only to HEAD
957 list_deps()
959 head_from=
960 [ "$1" != "-i" -a "$1" != "-w" ] || { head_from="$1"; shift; }
961 head="$(git symbolic-ref -q HEAD)" ||
962 head="..detached.."
964 git for-each-ref --format='%(objectname) %(refname)' "refs/$topbases${1:+/$1}" |
965 while read rev ref; do
966 name="${ref#refs/$topbases/}"
967 if branch_annihilated "$name" "" "$rev"; then
968 continue
971 from=$head_from
972 [ "refs/heads/$name" = "$head" ] ||
973 from=
974 cat_file "refs/heads/$name:.topdeps" $from | while read dep; do
975 dep_is_tgish=true
976 ref_exists "refs/$topbases/$dep" ||
977 dep_is_tgish=false
978 if ! "$dep_is_tgish" || ! branch_annihilated $dep; then
979 echo "$name $dep"
981 done
982 done
985 # switch_to_base NAME [SEED]
986 switch_to_base()
988 _base="refs/$topbases/$1"; _seed="$2"
989 # We have to do all the hard work ourselves :/
990 # This is like git checkout -b "$_base" "$_seed"
991 # (or just git checkout "$_base"),
992 # but does not create a detached HEAD.
993 git read-tree -u -m HEAD "${_seed:-$_base}"
994 [ -z "$_seed" ] || git update-ref "$_base" "$_seed"
995 git symbolic-ref HEAD "$_base"
998 # run editor with arguments
999 # the editor setting will be cached in $tg_editor (which is eval'd)
1000 # result non-zero if editor fails or GIT_EDITOR cannot be determined
1001 run_editor()
1003 tg_editor="$GIT_EDITOR"
1004 [ -n "$tg_editor" ] || tg_editor="$(git var GIT_EDITOR)" || return $?
1005 eval "$tg_editor" '"$@"'
1008 # Show the help messages.
1009 do_help()
1011 _www=
1012 if [ "$1" = "-w" ]; then
1013 _www=1
1014 shift
1016 if [ -z "$1" ] ; then
1017 # This is currently invoked in all kinds of circumstances,
1018 # including when the user made a usage error. Should we end up
1019 # providing more than a short help message, then we should
1020 # differentiate.
1021 # Petr's comment: http://marc.info/?l=git&m=122718711327376&w=2
1023 ## Build available commands list for help output
1025 cmds=
1026 sep=
1027 for cmd in "$TG_INST_CMDDIR"/tg-[!-]*; do
1028 ! [ -r "$cmd" ] && continue
1029 # strip directory part and "tg-" prefix
1030 cmd="${cmd##*/}"
1031 cmd="${cmd#tg-}"
1032 [ "$cmd" != "migrate-bases" ] || continue
1033 [ "$cmd" != "summary" ] || cmd="status|$cmd"
1034 cmds="$cmds$sep$cmd"
1035 sep="|"
1036 done
1038 echo "TopGit version $TG_VERSION - A different patch queue manager"
1039 echo "Usage: $tgname [-C <dir>] [-r <remote> | -u] [-c <name>=<val>] ($cmds) ..."
1040 echo " Or: $tgname help [-w] [<command>]"
1041 echo "Use \"$tgdisplaydir$tgname help tg\" for overview of TopGit"
1042 elif [ -r "$TG_INST_CMDDIR"/tg-$1 -o -r "$TG_INST_SHAREDIR/tg-$1.txt" ] ; then
1043 if [ -n "$_www" ]; then
1044 nohtml=
1045 if ! [ -r "$TG_INST_SHAREDIR/topgit.html" ]; then
1046 echo "${0##*/}: missing html help file:" \
1047 "$TG_INST_SHAREDIR/topgit.html" 1>&2
1048 nohtml=1
1050 if ! [ -r "$TG_INST_SHAREDIR/tg-$1.html" ]; then
1051 echo "${0##*/}: missing html help file:" \
1052 "$TG_INST_SHAREDIR/tg-$1.html" 1>&2
1053 nohtml=1
1055 if [ -n "$nohtml" ]; then
1056 echo "${0##*/}: use" \
1057 "\"${0##*/} help $1\" instead" 1>&2
1058 exit 1
1060 git web--browse -c help.browser "$TG_INST_SHAREDIR/tg-$1.html"
1061 exit
1063 output()
1065 if [ -r "$TG_INST_CMDDIR"/tg-$1 ] ; then
1066 "$TG_INST_CMDDIR"/tg-$1 -h 2>&1 || :
1067 echo
1068 elif [ "$1" = "help" ]; then
1069 echo "Usage: ${tgname:-tg} help [-w] [<command>]"
1070 echo
1071 elif [ "$1" = "status" ]; then
1072 echo "Usage: ${tgname:-tg} status [-v] [--exit-code]"
1073 echo
1075 if [ -r "$TG_INST_SHAREDIR/tg-$1.txt" ] ; then
1076 cat "$TG_INST_SHAREDIR/tg-$1.txt"
1079 page output "$1"
1080 else
1081 echo "${0##*/}: no help for $1" 1>&2
1082 do_help
1083 exit 1
1087 check_status()
1089 git_state=
1090 git_remove=
1091 if [ -e "$git_dir/MERGE_HEAD" ]; then
1092 git_state="merge"
1093 elif [ -e "$git_dir/rebase-apply/applying" ]; then
1094 git_state="am"
1095 git_remove="$git_dir/rebase-apply"
1096 elif [ -e "$git_dir/rebase-apply" ]; then
1097 git_state="rebase"
1098 git_remove="$git_dir/rebase-apply"
1099 elif [ -e "$git_dir/rebase-merge" ]; then
1100 git_state="rebase"
1101 git_remove="$git_dir/rebase-merge"
1102 elif [ -e "$git_dir/CHERRY_PICK_HEAD" ]; then
1103 git_state="cherry-pick"
1104 elif [ -e "$git_dir/BISECT_LOG" ]; then
1105 git_state="bisect"
1106 elif [ -e "$git_dir/REVERT_HEAD" ]; then
1107 git_state="revert"
1109 git_remove="${git_remove#./}"
1111 tg_state=
1112 tg_remove=
1113 if [ -e "$git_dir/tg-update" ]; then
1114 tg_state="update"
1115 tg_remove="$git_dir/tg-update"
1117 tg_remove="${tg_remove#./}"
1120 # Show status information
1121 do_status()
1123 do_status_result=0
1124 do_status_verbose=
1125 while [ $# -gt 0 ] && case "$1" in
1126 --verbose|-v)
1127 do_status_verbose=1
1129 --exit-code)
1130 do_status_result=2
1133 die "unknown status argument: $1"
1135 esac; do shift; done
1136 check_status
1137 symref="$(git symbolic-ref --quiet HEAD)" || :
1138 headrv="$(git rev-parse --quiet --verify --short HEAD --)" || :
1139 if [ -n "$symref" ]; then
1140 echol "HEAD -> $symref (${headrv:-unborn})"
1141 else
1142 echol "HEAD -> ${headrv:-?}"
1144 if [ -n "$tg_state" ]; then
1145 extra=
1146 if [ "$tg_state" = "update" ]; then
1147 IFS= read -r uname <"$git_dir/tg-update/name" || :
1148 [ -z "$uname" ] ||
1149 extra="; currently updating branch '$uname'"
1151 echol "tg $tg_state in progress$extra"
1152 if [ -s "$git_dir/tg-update/fullcmd" ] && [ -s "$git_dir/tg-update/names" ]; then
1153 printf 'You are currently updating as a result of:\n '
1154 cat "$git_dir/tg-update/fullcmd"
1155 bcnt="$(( $(wc -w < "$git_dir/tg-update/names") ))"
1156 if [ $bcnt -gt 1 ]; then
1157 pcnt=0
1158 ! [ -s "$git_dir/tg-update/processed" ] ||
1159 pcnt="$(( $(wc -w < "$git_dir/tg-update/processed") ))"
1160 echo "$pcnt of $bcnt branches updated so far"
1163 if [ "$tg_state" = "update" ]; then
1164 echol ' (use "tg update --continue" to continue)'
1165 echol ' (use "tg update --skip" to skip this branch and continue)'
1166 echol ' (use "tg update --stop" to stop and retain updates so far)'
1167 echol ' (use "tg update --abort" to restore pre-update state)'
1170 [ -z "$git_state" ] || echo "git $git_state in progress"
1171 if [ "$git_state" = "merge" ]; then
1172 ucnt="$(( $(git ls-files --unmerged --full-name --abbrev :/ | wc -l) ))"
1173 if [ $ucnt -gt 0 ]; then
1174 echo 'fix conflicts and then "git commit" the result'
1175 else
1176 echo 'all conflicts fixed; run "git commit" to record result'
1179 if [ -z "$git_state" ]; then
1180 ccnt="$(( $(git status --porcelain -uno | wc -l) ))"
1181 untr=
1182 if [ "$ccnt" -eq 0 ]; then
1183 if git status --porcelain | grep -q '^[?]'; then
1184 untr="; non-ignored, untracked files present"
1186 echo "working directory is clean$untr"
1187 [ -n "$tg_state" ] || do_status_result=0
1188 else
1189 echo "working directory is DIRTY"
1194 ## Pager stuff
1196 # isatty FD
1197 isatty()
1199 test -t $1
1202 # pass "diff" to get pager.diff
1203 # if pager.$1 is a boolean false returns cat
1204 # if set to true or unset fails
1205 # otherwise succeeds and returns the value
1206 get_pager()
1208 if _x="$(git config --bool "pager.$1" 2>/dev/null)"; then
1209 [ "$_x" != "true" ] || return 1
1210 echo "cat"
1211 return 0
1213 if _x="$(git config "pager.$1" 2>/dev/null)"; then
1214 echol "$_x"
1215 return 0
1217 return 1
1220 # setup_pager
1221 # Set TG_PAGER to a valid executable
1222 # After calling, code to be paged should be surrounded with {...} | eval "$TG_PAGER"
1223 # See also the following "page" function for ease of use
1224 # emptypager will be set to 1 (otherwise empty) if TG_PAGER was set to "cat" to not be empty
1225 # Preference is (same as Git):
1226 # 1. GIT_PAGER
1227 # 2. pager.$USE_PAGER_TYPE (but only if USE_PAGER_TYPE is set and so is pager.$USE_PAGER_TYPE)
1228 # 3. core.pager (only if set)
1229 # 4. PAGER
1230 # 5. git var GIT_PAGER
1231 # 6. less
1232 setup_pager()
1234 isatty 1 || { emptypager=1; TG_PAGER=cat; return 0; }
1236 emptypager=
1237 if [ -z "$TG_PAGER_IN_USE" ]; then
1238 # TG_PAGER = GIT_PAGER | PAGER | less
1239 # NOTE: GIT_PAGER='' is significant
1240 if [ -n "${GIT_PAGER+set}" ]; then
1241 TG_PAGER="$GIT_PAGER"
1242 elif [ -n "$USE_PAGER_TYPE" ] && _dp="$(get_pager "$USE_PAGER_TYPE")"; then
1243 TG_PAGER="$_dp"
1244 elif _cp="$(git config core.pager 2>/dev/null)"; then
1245 TG_PAGER="$_cp"
1246 elif [ -n "${PAGER+set}" ]; then
1247 TG_PAGER="$PAGER"
1248 else
1249 _gp="$(git var GIT_PAGER 2>/dev/null)" || :
1250 [ "$_gp" != ":" ] || _gp=
1251 TG_PAGER="${_gp:-less}"
1253 if [ -z "$TG_PAGER" ]; then
1254 emptypager=1
1255 TG_PAGER=cat
1257 else
1258 emptypager=1
1259 TG_PAGER=cat
1262 # Set pager default environment variables
1263 # see pager.c:setup_pager
1264 if [ -z "${LESS+set}" ]; then
1265 LESS="-FRX"
1266 export LESS
1268 if [ -z "${LV+set}" ]; then
1269 LV="-c"
1270 export LV
1273 # this is needed so e.g. $(git diff) will still colorize it's output if
1274 # requested in ~/.gitconfig with color.diff=auto
1275 GIT_PAGER_IN_USE=1
1276 export GIT_PAGER_IN_USE
1278 # this is needed so we don't get nested pagers
1279 TG_PAGER_IN_USE=1
1280 export TG_PAGER_IN_USE
1283 # page eval_arg [arg ...]
1285 # Calls setup_pager then evals the first argument passing it all the rest
1286 # where the output is piped through eval "$TG_PAGER" unless emptypager is set
1287 # by setup_pager (in which case the output is left as-is).
1289 # To handle arbitrary paging duties, collect lines to be paged into a
1290 # function and then call page with the function name or perhaps func_name "$@".
1292 # If no arguments at all are passed in do nothing (return with success).
1293 page()
1295 [ $# -gt 0 ] || return 0
1296 setup_pager
1297 _evalarg="$1"; shift
1298 if [ -n "$emptypager" ]; then
1299 eval "$_evalarg" '"$@"'
1300 else
1301 eval "$_evalarg" '"$@"' | eval "$TG_PAGER"
1305 # get_temp NAME [-d]
1306 # creates a new temporary file (or directory with -d) in the global
1307 # temporary directory $tg_tmp_dir with pattern prefix NAME
1308 get_temp()
1310 mktemp $2 "$tg_tmp_dir/$1.XXXXXX"
1313 # automatically called by strftime
1314 # does nothing if already setup
1315 # may be called explicitly if the first call would otherwise be in a subshell
1316 # so that the setup is only done once before subshells start being spawned
1317 setup_strftime()
1319 [ -z "$strftime_is_setup" ] || return 0
1321 # date option to format raw epoch seconds values
1322 daterawopt=
1323 _testes='951807788'
1324 _testdt='2000-02-29 07:03:08 UTC'
1325 _testfm='%Y-%m-%d %H:%M:%S %Z'
1326 if [ "$(TZ=UTC date "-d@$_testes" "+$_testfm" 2>/dev/null)" = "$_testdt" ]; then
1327 daterawopt='-d@'
1328 elif [ "$(TZ=UTC date "-r$_testes" "+$_testfm" 2>/dev/null)" = "$_testdt" ]; then
1329 daterawopt='-r'
1331 strftime_is_setup=1
1334 # $1 => strftime format string to use
1335 # $2 => raw timestamp as seconds since epoch
1336 # $3 => optional time zone string (empty/absent for local time zone)
1337 strftime()
1339 setup_strftime
1340 if [ -n "$daterawopt" ]; then
1341 if [ -n "$3" ]; then
1342 TZ="$3" date "$daterawopt$2" "+$1"
1343 else
1344 date "$daterawopt$2" "+$1"
1346 else
1347 if [ -n "$3" ]; then
1348 TZ="$3" perl -MPOSIX=strftime -le 'print strftime($ARGV[0],localtime($ARGV[1]))' "$1" "$2"
1349 else
1350 perl -MPOSIX=strftime -le 'print strftime($ARGV[0],localtime($ARGV[1]))' "$1" "$2"
1355 setup_git_dirs()
1357 [ -n "$git_dir" ] || git_dir="$(git rev-parse --git-dir)"
1358 if [ -n "$git_dir" ] && [ -d "$git_dir" ]; then
1359 git_dir="$(cd "$git_dir" && pwd)"
1361 if [ -z "$git_common_dir" ]; then
1362 if vcmp "$git_version" '>=' "2.5"; then
1363 # rev-parse --git-common-dir is broken and may give
1364 # an incorrect result unless the current directory is
1365 # already set to the top level directory
1366 git_common_dir="$(cd "./$(git rev-parse --show-cdup)" && cd "$(git rev-parse --git-common-dir)" && pwd)"
1367 else
1368 git_common_dir="$git_dir"
1371 [ -n "$git_dir" ] && [ -n "$git_common_dir" ] &&
1372 [ -d "$git_dir" ] && [ -d "$git_common_dir" ] || die "Not a git repository"
1373 git_hooks_dir="$git_common_dir/hooks"
1374 if vcmp "$git_version" '>=' "2.9" && gchp="$(git config --path --get core.hooksPath 2>/dev/null)" && [ -n "$gchp" ]; then
1375 case "$gchp" in
1376 /[!/]*)
1377 git_hooks_dir="$gchp"
1380 [ -n "$1" ] || warn "ignoring non-absolute core.hooksPath: $gchp"
1382 esac
1383 unset gchp
1387 basic_setup()
1389 setup_git_dirs $1
1390 [ -n "$base_remote" ] || base_remote="$(git config topgit.remote 2>/dev/null)" || :
1391 tgsequester="$(git config --bool topgit.sequester 2>/dev/null)" || :
1392 tgnosequester=
1393 [ "$tgsequester" != "false" ] || tgnosequester=1
1394 unset tgsequester
1396 # catch errors if topbases is used without being set
1397 unset tg_topbases_set
1398 topbases="programmer*:error"
1399 topbasesrx="programmer*:error}"
1400 oldbases="$topbases"
1403 ## Initial setup
1404 initial_setup()
1406 # suppress the merge log editor feature since git 1.7.10
1408 GIT_MERGE_AUTOEDIT=no
1409 export GIT_MERGE_AUTOEDIT
1411 basic_setup $1
1412 auhopt=
1413 ! vcmp "$git_version" '>=' "2.9" || auhopt="--allow-unrelated-histories"
1414 root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
1415 logrefupdates="$(git config --bool core.logallrefupdates 2>/dev/null)" || :
1416 [ "$logrefupdates" = "true" ] || logrefupdates=
1418 # make sure root_dir doesn't end with a trailing slash.
1420 root_dir="${root_dir%/}"
1422 # make sure global cache directory exists inside GIT_DIR
1424 tg_cache_dir="$git_common_dir/tg-cache"
1425 [ -d "$tg_cache_dir" ] || mkdir "$tg_cache_dir"
1427 # create global temporary directories, inside GIT_DIR
1429 tg_tmp_dir=
1430 trap 'rm -rf "$tg_tmp_dir"' EXIT
1431 trap 'exit 129' HUP
1432 trap 'exit 130' INT
1433 trap 'exit 131' QUIT
1434 trap 'exit 134' ABRT
1435 trap 'exit 143' TERM
1436 tg_tmp_dir="$(mktemp -d "$git_dir/tg-tmp.XXXXXX")"
1437 tg_ref_cache="$tg_tmp_dir/tg~ref-cache"
1440 set_topbases()
1442 # refer to "top-bases" in a refname with $topbases
1444 [ -z "$tg_topbases_set" ] || return 0
1446 topbases_implicit_default=1
1447 # See if topgit.top-bases is set to heads or refs
1448 tgtb="$(git config "topgit.top-bases" 2>/dev/null)" || :
1449 if [ -n "$tgtb" ] && [ "$tgtb" != "heads" ] && [ "$tgtb" != "refs" ]; then
1450 if [ -n "$1" ]; then
1451 # never die on the hook script
1452 unset tgtb
1453 else
1454 die "invalid \"topgit.top-bases\" setting (must be \"heads\" or \"refs\")"
1457 if [ -n "$tgtb" ]; then
1458 case "$tgtb" in
1459 heads)
1460 topbases="heads/{top-bases}"
1461 topbasesrx="heads/[{]top-bases[}]"
1462 oldbases="top-bases";;
1463 refs)
1464 topbases="top-bases"
1465 topbasesrx="top-bases"
1466 oldbases="heads/{top-bases}";;
1467 esac
1468 # MUST NOT be exported
1469 unset tgtb tg_topbases_set topbases_implicit_default
1470 tg_topbases_set=1
1471 return 0
1473 unset tgtb
1475 # check heads and top-bases and see what state the current
1476 # repository is in. remotes are ignored.
1478 hblist=" "
1479 topbases=
1480 both=
1481 newtb="heads/{top-bases}"
1482 while read -r rn && [ -n "$rn" ]; do case "$rn" in
1483 "refs/heads/{top-bases}"/*)
1484 case "$hblist" in *" ${rn#refs/$newtb/} "*)
1485 if [ "$topbases" != "heads/{top-bases}" ] && [ -n "$topbases" ]; then
1486 both=1
1487 break;
1488 else
1489 topbases="heads/{top-bases}"
1490 topbasesrx="heads/[{]top-bases[}]"
1491 oldbases="top-bases"
1493 esac;;
1494 "refs/top-bases"/*)
1495 case "$hblist" in *" ${rn#refs/top-bases/} "*)
1496 if [ "$topbases" != "top-bases" ] && [ -n "$topbases" ]; then
1497 both=1
1498 break;
1499 else
1500 topbases="top-bases"
1501 topbasesrx="top-bases"
1502 oldbases="heads/{top-bases}"
1504 esac;;
1505 "refs/heads"/*)
1506 hblist="$hblist${rn#refs/heads/} ";;
1507 esac; done <<-EOT
1508 $(git for-each-ref --format='%(refname)' "refs/heads" "refs/top-bases" 2>/dev/null)
1510 if [ -n "$both" ]; then
1511 if [ -n "$1" ]; then
1512 # hook script always prefers newer without complaint
1513 topbases="heads/{top-bases}"
1514 topbasesrx="heads/[{]top-bases[}]"
1515 oldbases="top-bases"
1516 else
1517 # Complain and die
1518 err "repository contains existing TopGit branches"
1519 err "but some use refs/top-bases/... for the base"
1520 err "and some use refs/heads/{top-bases}/... for the base"
1521 err "with the latter being the new, preferred location"
1522 err "set \"topgit.top-bases\" to either \"heads\" to use"
1523 err "the new heads/{top-bases} location or \"refs\" to use"
1524 err "the old top-bases location."
1525 err "(the tg migrate-bases command can also resolve this issue)"
1526 die "schizophrenic repository requires topgit.top-bases setting"
1528 elif [ -n "$topbases" ]; then
1529 unset topbases_implicit_default
1532 [ -n "$topbases" ] || {
1533 # default is still top-bases for now
1534 topbases="top-bases"
1535 topbasesrx="top-bases"
1536 oldbases="heads/{top-bases}"
1538 # MUST NOT be exported
1539 unset hblist both newtb rn tg_topases_set
1540 tg_topbases_set=1
1541 return 0
1544 # init_reflog "ref"
1545 # if "$logrefupdates" is set and ref is not under refs/heads/ then force
1546 # an empty log file to exist so that ref changes will be logged
1547 # "$1" must be a fully-qualified refname (i.e. start with "refs/")
1548 # However, if "$1" is "refs/tgstash" then always make the reflog
1549 # The only ref not under refs/ that Git will write a reflog for is HEAD;
1550 # no matter what, it will NOT update a reflog for any other bare refs so
1551 # just quietly succeed when passed TG_STASH without doing anything.
1552 init_reflog()
1554 [ -n "$1" ] && [ "$1" != "TG_STASH" ] || return 0
1555 [ -n "$logrefupdates" ] || [ "$1" = "refs/tgstash" ] || return 0
1556 case "$1" in refs/heads/*|HEAD) return 0;; refs/*[!/]);; *) return 1; esac
1557 mkdir -p "$git_common_dir/logs/${1%/*}" 2>/dev/null || :
1558 { >>"$git_common_dir/logs/$1" || :; } 2>/dev/null
1561 # store the "realpath" for "$2" in "$1" except the leaf is not resolved if it's
1562 # a symbolic link. The directory part must exist, but the basename need not.
1563 v_get_abs_path()
1565 [ -n "$1" ] && [ -n "$2" ] || return 1
1566 set -- "$1" "$2" "${2%/}"
1567 case "$3" in
1568 */*) set -- "$1" "$2" "${3%/*}";;
1569 * ) set -- "$1" "$2" ".";;
1570 esac
1571 [ -d "$3" ] || return 1
1572 eval "$1="'"$(cd "$3" && pwd -P)/${2##*/}"'
1575 ## Startup
1577 : "${TG_INST_CMDDIR:=@cmddir@}"
1578 : "${TG_INST_SHAREDIR:=@sharedir@}"
1579 : "${TG_INST_HOOKSDIR:=@hooksdir@}"
1581 [ -d "$TG_INST_CMDDIR" ] ||
1582 die "No command directory: '$TG_INST_CMDDIR'"
1584 if [ -n "$tg__include" ]; then
1586 # We were sourced from another script for our utility functions;
1587 # this is set by hooks. Skip the rest of the file. A simple return doesn't
1588 # work as expected in every shell. See http://bugs.debian.org/516188
1590 # ensure setup happens
1592 initial_setup 1
1593 set_topbases 1
1595 else
1597 set -e
1599 tg="$0"
1600 tgdir="${tg%/}"
1601 case "$tgdir" in */*);;*) tgdir="./$tgdir"; esac
1602 tgdir="${tgdir%/*}/"
1603 tgname="${tg##*/}"
1604 [ "$0" != "$tgname" ] || tgdir=""
1606 # If tg contains a '/' but does not start with one then replace it with an absolute path
1608 case "$0" in /*) ;; */*)
1609 tgdir="$(cd "${0%/*}" && pwd -P)/"
1610 tg="$tgdir$tgname"
1611 esac
1613 # If the tg in the PATH is the same as "$tg" just display the basename
1614 # tgdisplay will include any explicit -C <dir> option whereas tg will not
1616 tgdisplaydir="$tgdir"
1617 tgdisplay="$tg"
1619 v_get_abs_path _tgabs "$tg" &&
1620 v_get_abs_path _tgnameabs "$(cmd_path "$tgname")" &&
1621 [ "$_tgabs" = "$_tgnameabs" ]
1622 then
1623 tgdisplaydir=""
1624 tgdisplay="$tgname"
1626 unset _tgabs _tgnameabs
1628 explicit_remote=
1629 explicit_dir=
1630 gitcdopt=
1631 noremote=
1633 cmd=
1634 while :; do case "$1" in
1636 help|--help|-h)
1637 cmd=help
1638 shift
1639 break;;
1641 status|--status)
1642 cmd=status
1643 shift
1644 break;;
1646 --hooks-path)
1647 cmd=hooks-path
1648 shift
1649 break;;
1651 --top-bases)
1652 cmd=top-bases
1653 shift
1654 break;;
1657 shift
1658 if [ -z "$1" ]; then
1659 echo "Option -r requires an argument." >&2
1660 do_help
1661 exit 1
1663 unset noremote
1664 base_remote="$1"
1665 explicit_remote="$base_remote"
1666 tg="$tgdir$tgname -r $explicit_remote"
1667 tgdisplay="$tgdisplaydir$tgname"
1668 [ -z "$explicit_dir" ] || tgdisplay="$tgdisplay -C \"$explicit_dir\""
1669 tgdisplay="$tgdisplay -r $explicit_remote"
1670 shift;;
1673 unset base_remote explicit_remote
1674 noremote=1
1675 tg="$tgdir$tgname -u"
1676 tgdisplay="$tgdisplaydir$tgname"
1677 [ -z "$explicit_dir" ] || tgdisplay="$tgdisplay -C \"$explicit_dir\""
1678 tgdisplay="$tgdisplay -u"
1679 shift;;
1682 shift
1683 if [ -z "$1" ]; then
1684 echo "Option -C requires an argument." >&2
1685 do_help
1686 exit 1
1688 cd "$1"
1689 unset GIT_DIR GIT_COMMON_DIR
1690 explicit_dir="$1"
1691 gitcdopt=" -C \"$explicit_dir\""
1692 tg="$tgdir$tgname"
1693 tgdisplay="$tgdisplaydir$tgname -C \"$explicit_dir\""
1694 [ -z "$explicit_remote" ] || tg="$tg -r $explicit_remote"
1695 [ -z "$explicit_remote" ] || tgdisplay="$tgdisplay -r $explicit_remote"
1696 [ -z "$noremote" ] || tg="$tg -u"
1697 [ -z "$noremote" ] || tg="$tgdisplay -u"
1698 shift;;
1701 shift
1702 if [ -z "$1" ]; then
1703 echo "Option -c requires an argument." >&2
1704 do_help
1705 exit 1
1707 param="'$(printf '%s\n' "$1" | sed "s/[']/'\\\\''/g")'"
1708 GIT_CONFIG_PARAMETERS="${GIT_CONFIG_PARAMETERS:+$GIT_CONFIG_PARAMETERS }$param"
1709 export GIT_CONFIG_PARAMETERS
1710 shift;;
1713 shift
1714 break;;
1717 echo "Invalid option $1 (subcommand options must appear AFTER the subcommand)." >&2
1718 do_help
1719 exit 1;;
1722 break;;
1724 esac; done
1726 [ -n "$cmd" -o $# -lt 1 ] || { cmd="$1"; shift; }
1728 ## Dispatch
1730 [ -n "$cmd" ] || { do_help; exit 1; }
1732 case "$cmd" in
1734 help)
1735 do_help "$@"
1736 exit 0;;
1738 status)
1739 unset base_remote
1740 basic_setup
1741 set_topbases
1742 do_status "$@"
1743 exit ${do_status_result:-0};;
1745 hooks-path)
1746 # Internal command
1747 echol "$TG_INST_HOOKSDIR";;
1749 top-bases)
1750 # Maintenance command
1751 setup_git_dirs
1752 set_topbases
1753 echol "refs/$topbases";;
1756 isutil=
1757 case "$cmd" in index-merge-one-file)
1758 isutil="-"
1759 esac
1760 [ -r "$TG_INST_CMDDIR"/tg-$isutil$cmd ] || {
1761 echo "Unknown subcommand: $cmd" >&2
1762 do_help
1763 exit 1
1766 showing_help=
1767 if [ "$*" = "-h" ] || [ "$*" = "--help" ]; then
1768 showing_help=1
1771 [ -n "$showing_help" ] || initial_setup
1772 [ -z "$noremote" ] || unset base_remote
1774 nomergesetup="$showing_help"
1775 case "$cmd" in base|info|log|summary|rebase|revert|tag)
1776 # avoid merge setup where not necessary
1778 nomergesetup=1
1779 esac
1781 if [ -z "$nomergesetup" ]; then
1782 # make sure merging the .top* files will always behave sanely
1784 setup_ours
1785 setup_hook "pre-commit"
1788 # everything but rebase needs topbases set
1789 carefully="$showing_help"
1790 [ "$cmd" != "migrate-bases" ] || carefully=1
1791 [ "$cmd" = "rebase" ] || set_topbases $carefully
1793 _use_ref_cache=
1794 tg_read_only=1
1795 case "$cmd$showing_help" in
1796 summary|info|export|tag)
1797 _use_ref_cache=1;;
1798 annihilate|create|delete|depend|import|update)
1799 tg_read_only=;;
1800 esac
1801 [ -z "$_use_ref_cache" ] || v_create_ref_cache
1803 fullcmd="${tgname:-tg} $cmd $*"
1804 . "$TG_INST_CMDDIR"/tg-$isutil$cmd;;
1805 esac